// "ADC channel_LEDvichitOK_avp\ch.c"
//  0  9,99    10,0  99,9 
//    
//  
//Program size: 225 words (5,5% of FLASH)
// 1   (..)
//(PORTD - ) - a-bit0, b-bit1, c-bit2, d-bit3, e-bit4, f-bit5, g-bit6                  
//(PORTD bit 7 -  dp)
//PORTB.0       
//PORTB.1        
//PORTB.2       

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


char r0;                           //  1-  ()     
unsigned int adc_data; 
char Vsot;
char Vdes;
char Ved;
unsigned int ind;                  //   . .      
unsigned int ind_u;                //  AVRSt-
                                       
flash char digits[] =              //     
{
0b0111111,   //0     0b00111111,           
0b0000110,   //1     0b00000110,          
0b1011011,   //2     0b01011011,           
0b1001111,   //3     0b01001111,           
0b1100110,   //4     0b01100110,           
0b1101101,   //5     0b01101101,          
0b1111101,   //6     0b01111101,           
0b0000111,   //7     0b00000111,
0b1111111,   //8     0b01111111,
0b1101111    //9     0b01101111
};                  

void hex_to_dec(void)           //    hex  dec 
{
    Vsot=0;                     //  
    while (ind>=100)            //   while (ind>=100) 
    {
    ind-=100;
    Vsot++;
    }
  
    Vdes=0;                     //  
    while (ind>=10)             //   (ind>=10)
    {
    ind-=10;
    Vdes++;
    }
  
    Ved=0;                      //  
    while (ind>=1)              //   while (ind>=1)
    {
    ind-=1;
    Ved++;
    };
} 
                 
void read(void)                 //  
{        
  ADCSRA|=0x40;                 //               
  delay_us(20);
  while ((ADCSRA & 0x10)==0);   //   
  
  adc_data=ADCW;                // adc_data
  delay_ms(2);
  ind=adc_data;
  ind_u=ind;
  hex_to_dec();
  
   //  ""
       switch (r0)
       { 
       case 0:                // 1
       PORTB=0b11111110;      // 0  B.0
       PORTD=digits[Vsot];      
       break;  	 
      
       case 1:                // 2
       PORTB=0b11111101;      // 0  B.1
       PORTD=digits[Vdes];  
       break;  	 
       
       case 2:                // 3
       PORTB=0b11111011;      // 0  B.2
       PORTD=digits[Ved];   
       break;  	
      }                                        
      //***    9   15  ********************
      if (r0==0&&PINC.5==0)   // .  < 10  
      {
      PORTD.7=1;              //.   U<10
      }                       // 1-  
      
      if (r0==0&&PINC.5==1)   //.    . .
      {                       //>9,99 
      PORTD.7=0;
      } 
      
      if (r0==1&&ind_u>=1000)            // 
      //if (r0==1&&ind_u==999&&ind_u>=1001)  // 
      {
      delay_ms(2);
      PORTC.5=1;
      }  
      
      if (r0==1&&PINC.5==1)   // .   U> 10 
      PORTD.7=1;              //    
                              // 2-  
      //***************** ****************   
      
      //***    15   9  ********************
      if (r0==0&&Vsot==0&&PINC.5==1)    // 
      {                                
      delay_ms(2);
      PORTC.5=0;
      }
      //
      
      r0++;                   // r  1   
      if (r0==3) r0=0;        // r = 3   
}                

void main(void)                   
{                 
//  B   (   0)
 DDRB=0b11111111;
PORTB=0b00000000;

//  C   (   1) 
 DDRC=0b1111100; //0b0011111  PC.0,PC1  . PC.5  .(1-  0= )
PORTC=0b0000000; //0b0000001    1- 0-

//  D   (   1)
 DDRD=0b11111111;
PORTD=0b00000000;

//   0  
TCCR0=0b000000000; //
TCNT0=0x00;  

// Timer(s)/Counter(s) Interrupt(s) initialization 
TIMSK=0x00; //0b10     / 0

//  
//   bit 2-0 101=k=32 4000/32=125    
ADCSRA=0b10000101;  //bit7-            
ADMUX=0b11000000; // bit 7,6 . =2,56 0  -PC0  

   while(1)
     {    
       read();                                    
     }
}
